/****************************
CrushFTP GUI Panel custom js
*****************************/
/* Do not change these lines */
var panelGeneralSettings = {};
panelGeneralSettings.localization = {};
/****************************/

// Panel details
var panelName = "GeneralSettings";
var _panel = $("#pnl" + panelName);

// Localizations
panelGeneralSettings.localization = {
	headerText : "General Settings",
	lblMaxGlobalServerConnectionsText : "Max Global Server Connections :",
	lblMaxServerOutgoingSpeedText : "Max Server Outgoing Speed :",
	lblSpeedText : "K/sec",
	lblMaxServerIncomingSpeedText : "Incoming :",
	lblSpeedText : "K/sec",
	lblIPPatternsImmuneToSpeedText : "IP Patterns Immune To Speed :",
	lblReportSettingText : " Reports / Statistics Settings ",
	lblSaveStatisticsToDiskIntervalText : "Save statistics to disc interval in minutes :",
	lblTrackDaysWorthSessionHistoryText : "Track how many days worth session history :",
	lblTrackDaysWorthTransferHistoryText : "Track how many days worth transfer history :",
	lblSMTPServerUsedForEmailingText : "SMTP Server Used for Emailing :",
	lblSMTPServerUsernameText : "SMTP Server Username :",
	lblCheckBoxSSLOrTLSText : "SSL/TLS",
	lblCheckBoxHTMLText : "HTML",
	lblSMTPServerPasswordText : "SMTP Server Password :",
	btnTestSMTPSettingsText : "Test SMTP Settings",
	lblSMTPServerFromEmaiText : "From email address :",
	lblFTPWelcomeMessageText : "FTP Welcome Message :",
	lblMoveDeletedFilesToTempFolderText : "Move 'deleted' files/folders to temp folder. (Trash/Recycle bin)",
	btnBrowseText : "Browse",
	btnResetText : "Reset All Prefs to Default",
	btnCancelText : "Cancel",
	btnOKText : "Ok"
};

// Assign localizations
localizations.panels[panelName] = $.extend(panelGeneralSettings.localization, localizations.panels[panelName]);

// Interface methods
panelGeneralSettings.init = function(){
	applyLocalizations(panelName, localizations.panels);
	setPageTitle(panelGeneralSettings.localization.Header, true);
	panelGeneralSettings.bindData();
}

panelGeneralSettings.bindData = function()
{
	bindValuesFromXML(_panel
		, $(document).data("GUIXMLPrefs"));
	panelGeneralSettings.bindEvents();
}

panelGeneralSettings.bindEvents = function()
{
	$("a.serverFilePickButton", _panel).each(function(){
		$(this).click(function(){
			var curElem = $(this);
			curElem.crushFtpVFSBrowserPopup({
				type : curElem.attr("PickType") || 'dir',
				callback : function(selectedPath){
					$("#" + curElem.attr("rel"), _panel).val(selectedPath).trigger("change");
				}
			});
			return false;
		});
	});

	$("a#testSMTPSettings", _panel).click(function(){
		if($(this).attr("disabled"))return false;
		jPrompt("Please enter a 'From' email address : ", "", "From Address", function(fromEmail){
			if(fromEmail && fromEmail.length>0)
			{
				jPrompt("Please enter a 'To' email address : ", "", "To Address", function(toEmail){
					if(toEmail && toEmail.length>0)
					{
						var obj = {
							command : "testSMTP",
							to : toEmail,
							cc : "",
							bcc : "",
							from : fromEmail,
							subject : "Email Test",
							body : "This is the body of the test message.",
							server : $("#smtp_server", _panel).val(),
							user : $("#smtp_user", _panel).val(),
							pass : common.methods.htmlEncode($("#smtp_pass", _panel).val()),
							ssl : $("#smtp_ssl", _panel).is(":checked"),
							html : $("#smtp_html", _panel).is(":checked")
						};
						$("a#testSMTPSettings", _panel).block({
							message:  'Wait..',
							css: {
								border: 'none',
								padding: '0px 10px',
								backgroundColor: '#000',
								'-webkit-border-radius': '10px',
								'-moz-border-radius': '10px',
								opacity: .5,
								color: '#fff',
								'text-align':'left'
							}
						}).attr("disabled", "disabled");
						common.data.serverRequest(obj, function(msg){
							$("a#testSMTPSettings", _panel).unblock().removeAttr("disabled");
							growl("Testing SMTP Settings", decodeURIComponent($(msg).text()), false, false);
						});
					}
				}, false, false, {
					messageToAppend : '<div class="ui-corner-all warning left" style="padding:5px;display:block;margin:0px 0px 10px 100px;"><span style="float: left; margin-right: 0.3em;" class="ui-icon ui-icon-info"></span>Can not be blank</div>'
				});
			}
		}, false, false, {
			messageToAppend : '<div class="ui-corner-all warning left" style="padding:5px;display:block;margin:0px 0px 10px 100px;"><span style="float: left; margin-right: 0.3em;" class="ui-icon ui-icon-info"></span>Can not be blank</div>'
		});
		return false;
	});
}

panelGeneralSettings.saveContent = function()
{
	if(placeHolder.data("hasChanged"))
	{
		common.UI.showIndicator(false, false, "Please wait..");
		var dataXML = '<server_prefs type="properties">'+buildXMLToSubmitForm(_panel)+'</server_prefs>';
		common.data.setXMLPrefs("server_settings/server_prefs/"
				, "properties"
				, "update"
				, dataXML
				, function(data){
					data = $.xml2json(data, true);
					if(data.response_status && getTextValueFromXMLNode(data.response_status) && getTextValueFromXMLNode(data.response_status) == "OK")
					{
						common.data.updateLocalPrefs(function(){
							common.UI.hideIndicator();
							growl("Data saved", "Your changes are saved", false, 5000);
							placeHolder.removeData("hasChanged");
						});
					}
					else
					{
						growl("Error while saving", "Your changes are not saved", true);
					}
			});
	}
	else
	{
		growl("No changes made", "", false, 3000);
	}
}