/****************************
CrushFTP GUI Plugin custom js
*****************************/
/* Do not change these lines */
var pluginContentBlocker = {};
pluginContentBlocker.localization = {};
/****************************/

// Plugin details
var pluginName = "ContentBlocker";
var _plugin = $("#pnlPlugin" + pluginName);

// Localizations
pluginContentBlocker.localization = {
	lblEnabledText : "Enabled",
	lblDebugText : "Debug",
	lblVersionText : "Version : ",
	lblSetupTabText : "Setup",
	lblHelpTabText : "Help",
	lblUsernamesToMonitorText : "Usernames to monitor : ",
	lblUsernameInstructionText : " (Separate multiple usernames with a comma) ",
	lblListOfFPTPathNoteText : " List of FTP paths to watch and unzip uploads. (Example : '/uploads/')",
	btnAddPathText : " Add Path",
	btnEditPathText : " Edit Selected ",
	btnRemovePathText : " Remove Selected ",
	lblListOfAllowedExtensionsText : "List of allowed extensions for uploads from above directory selection :",
	btnAddExtensionText : "Add",
	btnEditExtensionText : "Edit",
	btnRemoveExtensionText : "Remove",
	pnlHelpText : "<strong>ContentBlocker Help</strong> <br> <br> This plugin allows you to block uploads of files that don't have an allowed extension. So for example, you could have a folder named 'PDFs', and a folder named 'IMAGES'.You could set the PDFs folder to only except '.PDF' files, and the IMAGES folder to only accept 'JPG', '.PNG', '.GIF', '.TIF', '.TIFF', etc. If the file being uploaded does not have ths proper extension, then it will be blocked. This plugin also prevents a user from renaming a file to a non allowed extension... so they couldn't upload stuff.gif, then rename it to stuff.exe for example. <br> <br> To use, enter a list of usernames this plugin will monitor. Then add FTP paths to the list of monitored directories. An FTP path is ths path that the user sees from their FTP client, not the real physical path on your HD. All uploads inside of that location will be monitored and blocked when appropriate. <br> <br> Questions? Email me: ben@crushftp.com <br> --Ben Spink"
};

// Assign localizations
localizations.panels["Plugins"][pluginName] = $.extend(pluginContentBlocker.localization, localizations.panels["Plugins"][pluginName]);

// Interface methods
pluginContentBlocker.init = function(pluginID, returnXML){
	pluginContentBlocker.returnXML = returnXML;
	applyLocalizations(pluginName, localizations.panels["Plugins"]);
	pluginContentBlocker.bindData(0, pluginID);
}

pluginContentBlocker.bindData = function(index, pluginID)
{
	index = index || 0;
	var pluginPrefs = [];
	if(pluginID)
	{
		var data = $(document).data("PluginBindData" + pluginID);
		pluginPrefs = data.dataItem;
		$(".nonEmbed", _plugin).hide();
	}
	else
	{
		pluginPrefs = common.data.getPluginPrefs(pluginName);
	}
	if(pluginPrefs)
	{
		var curPlugin = pluginPrefs;
		if(!pluginID && pluginPrefs.length)
		{
			curPlugin = pluginPrefs[index];
		}
		pluginContentBlocker.bindPluginDetails(curPlugin);
	}
	pluginContentBlocker.bindTrackedItems($("#pathList", _plugin).find(".ui-widget-header"));
	pluginContentBlocker.bindEvents();
}

pluginContentBlocker.bindEvents = function()
{
	if(this.eventAdded)return;
	var pathList = $("#pathList", _plugin);
	var extensionList = $("#allowedExtensions", _plugin);
	pathList.selectable({
		selected: function(event, ui) {
			var selected = $(ui.selected);
			pathList.find(".ui-widget-header").removeClass("ui-widget-header");
			selected.addClass("ui-widget-header");
			pluginContentBlocker.bindTrackedItems(selected);
			return false;
		}
	});

	$("#allowedExtensions", _plugin).selectable({
		selected: function(event, ui) {
			var selected = $(ui.selected);
			$("#allowedExtensions", _plugin).find(".ui-widget-header").removeClass("ui-widget-header");
			selected.addClass("ui-widget-header");
			return false;
		}
	});

	$("a#removePath", _plugin).click(function(){
		common.UI.removeItem(pathList, function(selected){
			pluginContentBlocker.bindTrackedItems(pathList.find("li.ui-selected"));
			panelPlugins.itemsChanged(true, pluginContentBlocker.returnXML, pluginName);
		});
		return false;
	});

	$("a#addNewPath", _plugin).click(function(evt, control){
		var actionName = "";
		if(control)
		{
			actionName = control.attr("path");
		}
		jPrompt("Enter a FTP path to monitor :", actionName, "Input", function(value){
			actionName = value;
			if(actionName!=null)
			{
				if(actionName.length == 0)
				{
					$("#addPath", _panel).trigger("click");
					return;
				}
				if(control)
				{
					control.text(actionName).attr("path", actionName);
				}
				else
				{
					var newControl = $("<li class='ui-widget-content' path='"+actionName+"'>" + actionName +"</li>");
					pathList.append(newControl);
					newControl.parent().find(".ui-widget-header").removeClass("ui-widget-header").removeClass("ui-selected");
					newControl.addClass("ui-widget-header").addClass("ui-selected");
					newControl.data("controlData", {
						"path":actionName,
						"tracked" :  [{
							tracked_subitem : []
						}]
					});
				}
				panelPlugins.itemsChanged(true, pluginContentBlocker.returnXML, pluginName);
				pluginContentBlocker.bindTrackedItems(pathList.find("li.ui-selected"));
			}
		});
		return false;
	});

	$("a#editPath", _plugin).click(function(){
		if(pathList.find("li.ui-selected").length>0)
		{
			var selected = pathList.find("li.ui-selected");
			$("#addNewPath", _panel).trigger("click", [selected]);
		}
		return false;
	});

	_plugin.find("input, select, textarea").bind("change", function(){
		panelPlugins.itemsChanged(true, pluginContentBlocker.returnXML, pluginName);
	});

	_plugin.find("input[type='text'], textarea").bind("textchange", function(){
		panelPlugins.itemsChanged(true, pluginContentBlocker.returnXML, pluginName);
	});

	$("a#addExtension", _plugin).click(function(){
		if(pathList.find("li.ui-selected").length>0)
		{
			var selected = pathList.find("li.ui-selected");
			jPrompt("Enter an extension to allow :", "", "Input", function(extension){
				if(extension!=null && extension.length > 0)
				{
					extension = extension.toUpperCase();
					var controlData = selected.data("controlData");
					if(!controlData.tracked)
					{
						controlData.tracked = [{
							tracked_subitem : []
						}];
					}
					controlData.tracked[0].tracked_subitem.push({
						text : extension
					});
					pluginContentBlocker.bindTrackedItems(selected);
					panelPlugins.itemsChanged(true, pluginContentBlocker.returnXML, pluginName);
				}
			});
		}
		return false;
	});

	$("a#editExtension", _plugin).click(function(){
		if(extensionList.find("li.ui-selected").length>0)
		{
			var selected = extensionList.find("li.ui-selected");
			jPrompt("Enter an extension to allow :",  selected.text(), "Input", function(extension){
				if(extension!=null && extension.length > 0)
				{
					extension = extension.toUpperCase();
					selected.text(extension);
					var selectedDir = pathList.find("li.ui-selected");
					var controlData = selectedDir.data("controlData");
					controlData.tracked[0].tracked_subitem[selected.index()].text = extension;
					panelPlugins.itemsChanged(true, pluginContentBlocker.returnXML, pluginName);
				}
			});
		}
		return false;
	});

	$("a#removeExtension", _plugin).click(function(){
		if(extensionList.find("li.ui-selected").length>0)
		{
			var selected = extensionList.find("li.ui-selected");
			var selectedDir = pathList.find("li.ui-selected");
			var controlData = selectedDir.data("controlData");
			controlData.tracked[0].tracked_subitem.remove(selected.index());
			selected.remove();
			extensionList.find("li:last").addClass("ui-widget-header ui-selected");
			panelPlugins.itemsChanged(true, pluginContentBlocker.returnXML, pluginName);
		}
		return false;
	});

	this.eventAdded = true;
}

pluginContentBlocker.bindPluginDetails = function(controlData)
{
	var inputs = _plugin.find("input.ignoreBind,select.ignoreBind,textarea.ignoreBind").removeClass("ignoreBind");
	bindValuesFromXML(_plugin, controlData);
	if(controlData.subItem && controlData.subItem.length>0)
		_plugin.attr("subPluginName", controlData.subItem[0].text || false);
	inputs.addClass("ignoreBind");
	var pathList = $("#pathList", _plugin).empty();
	if(controlData && controlData["dir_list"])
	{
		var dir_list = controlData["dir_list"];
		if(dir_list.length>0)
		{
			dir_list = dir_list[0]["dir_list_subitem"];
			if(dir_list)
			{
				for(var i=0;i<dir_list.length;i++)
				{
					var curItem = dir_list[i];
					if(curItem && curItem.path && curItem.path.length>0)
					{
						var path = curItem.path[0].text;
						var newControl = $("<li class='ui-widget-content' path='"+path+"'>" + path +"</li>");
						pathList.append(newControl);
						newControl.data("controlData", curItem);
					}
				}
			}
		}
	}
}

pluginContentBlocker.bindTrackedItems = function(selected)
{
	var tracksPanel = $("#trackedItems", _plugin);
	if(!selected || selected.length == 0)
	{
		tracksPanel.hide();
		return;
	}
	var path = selected.data("controlData");
	tracksPanel.show();
	var nameList = $("#allowedExtensions", tracksPanel).empty();
	if(path["tracked"])
	{
		var tracked_list = path["tracked"];
		if(tracked_list.length>0)
		{
			tracked_list = tracked_list[0]["tracked_subitem"];
			if(tracked_list)
			{
				for(var i=0;i<tracked_list.length;i++)
				{
					var curItem = tracked_list[i];
					if(curItem && curItem.text)
					{
						var path = curItem.text;
						var newControl = $("<li class='ui-widget-content'>"+unescape(path)+"</li>");
						nameList.append(newControl);
						newControl.data("controlData", curItem).data("trackedItem", path);
					}
				}
			}
		}
	}
}

pluginContentBlocker.saveContent = function(saveByIndex, cloneName, removeByIndex, callback)
{
	removeByIndex = removeByIndex || 0;
	if(pluginPlaceHolder.data("hasChanged") || removeByIndex>0 || (saveByIndex>0 && cloneName) || pluginContentBlocker.returnXML)
	{
		if(!pluginContentBlocker.returnXML)
			common.UI.showIndicator(false, false, "Please wait..");
		var xmlString = [];
		var container = _plugin;
		if(removeByIndex == 0)
		{
			xmlString.push("<plugins_subitem type=\"properties\">");
			xmlString.push("<version>"+$("#version", container).text()+"</version>");
			xmlString.push("<debug>"+$("#debug", container).is(":checked")+"</debug>");
			xmlString.push("<usernames>"+common.methods.htmlEncode($("#usernames", container).val())+"</usernames>");
			xmlString.push("<enabled>"+$("#enabled", container).is(":checked")+"</enabled>");
			xmlString.push("<pluginName>"+pluginName+"</pluginName>");
			var pathList = $("#pathList", container).find("li");
			if(pathList.length>0)
			{
				xmlString.push("<dir_list type=\"vector\">");
				pathList.each(function(){
					xmlString.push("<dir_list_subitem type=\"properties\">");
					xmlString.push("<path>"+common.methods.htmlEncode($(this).attr("path"))+"</path>");
					xmlString.push("<tracked type=\"vector\">");
					var controlData = $(this).data("controlData");
					if(controlData["tracked"])
					{
						var trackedPath = controlData["tracked"];
						if(trackedPath.length>0)
						{
							var tracked_list = trackedPath[0]["tracked_subitem"];
							if(tracked_list)
							{
								for(var i=0;i<tracked_list.length;i++)
								{
									var curItem = tracked_list[i];
									if(curItem && curItem.text)
									{
										xmlString.push("<tracked_subitem>"+common.methods.htmlEncode(curItem.text)+"</tracked_subitem>");
									}
								}
							}
						}
					}
					xmlString.push("</tracked>");
					xmlString.push("</dir_list_subitem>");
				});
				xmlString.push("</dir_list>");
			}
			if(saveByIndex)
			{
				xmlString.push("<subItem>"+common.methods.htmlEncode(cloneName)+"</subItem>");
			}
			else
			{
				if(container.attr("subPluginName") && this.subItem>0)
				{
					xmlString.push("<subItem>"+common.methods.htmlEncode(container.attr("subPluginName"))+"</subItem>");
				}
				else
				{
					xmlString.push("<subItem></subItem>");
				}
			}
			xmlString.push("</plugins_subitem>");
		}
		var formSubItem = xmlString.join("\n");

		if(pluginContentBlocker.returnXML)
			return formSubItem;

		var action = removeByIndex == 0 ? "change" : "remove";
		var index = window.currentPluginIndex;
		var subItemIndex = removeByIndex == 0 ? saveByIndex || this.subItem : removeByIndex;
		subItemIndex = subItemIndex || 0;
		var removeChangeFlag = (saveByIndex>0 && cloneName);
		panelPlugins.savePluginContentProcess(action, formSubItem, index, subItemIndex, removeChangeFlag, callback);
	}
	else
	{
		growl("No changes made", "", false, 3000);
	}
}