/****************************
CrushFTP GUI Panel custom js
*****************************/
/* Do not change these lines */
var panelSetup = {};
panelSetup.localization = {};
/****************************/

// Panel details
var panelName = "Setup";

panelSetup._panel = $("#pnl" + panelName);
panelSetup.serverDirSelectList = $("#serverDirSelectList", panelSetup._panel);
panelSetup.serverDirBrowsePanel = $("#serverDirBrowsePanel", panelSetup._panel);
panelSetup.userDirSelectList = $("#userDirSelectList", panelSetup._panel);
panelSetup.vfsItemsDirList = $("#vfsItems", panelSetup._panel);
panelSetup.vfsItemOperations = $("#vfsItemOperations", panelSetup._panel);
panelSetup.serverItemOperations = $("#serverItemOperations", panelSetup._panel);

// Localizations
panelSetup.localization = {
};

// Assign localizations
localizations.panels[panelName] = $.extend(panelSetup.localization, localizations.panels[panelName]);

// Interface methods
panelSetup.init = function(){
	applyLocalizations(panelName, localizations.panels);
	window.dataBindEvents.push(panelSetup.bindData);
	panelSetup.bindEvents();
}

panelSetup.clearForm = function(panel)
{
	panel = panel || panelSetup._panel;
	panel.find("input, select, textarea").each(function(){
		if($(this).attr("id") != "serverDirSelectList" && !$(this).hasClass("ui-autocomplete-input"))
		{
			if($(this).attr("type")=="checkbox")
			{
				if($(this).closest("td").is(".checkboxArea"))return;
				userManager.UI.checkUnchekInput($(this));
			}
			else
			{
				$(this).val("");
			}
		}
	});
}

panelSetup.bindData = function(userInfo, jsonDeep, panel)
{
	if(userManager.storage("userName") && userManager.storage("userName").toLowerCase() == "default")
	{
		$("#vfsItemsListingAndOptions", panelSetup._panel).addClass("notInheritable").find("td.checkboxArea").addClass("noInherit");
	}
	else
	{
		$("#vfsItemsListingAndOptions", panelSetup._panel).removeClass("notInheritable").find("td.checkboxArea").removeClass("noInherit");
	}

	panelSetup.buildDirPrivs();
	var dataPanel = panel || panelSetup._panel;
	panelSetup.clearForm(dataPanel);
	if(panel)
	{
		panel.removeClass("inheritValSet");
	}
	if(userInfo.user)
	{
		userManager.data.bindValuesFromJson(dataPanel, userInfo.user, false, panel);
		var dataInheritedFrom = false;
		var curData = userManager.methods.seperateValueAndInheritValue(userManager.data.getValueFromJson(userInfo.user, "max_logins"));
		var curVal = curData.value;
		dataInheritedFrom = curData.inherit || dataInheritedFrom;
		var chkAccount_enabled = $("#account_enabled", dataPanel);
		userManager.UI.checkUnchekInput(chkAccount_enabled, parseInt(curVal)>=0);
		var username = $("#user_name", dataPanel);
		var password = $("#password", dataPanel);
		if(username.length>0 && password.length>0)
		{
			username = username.val().toLowerCase();
			password.removeClass("ignoreBlank");
			if(userManager.usernamesToIgnorePasswordValidation.has(username))
			{
				password.attr("valtype", "").validateNow();
			}
			else
			{
				if($(document).data("GUIXMLPrefs") && $(document).data("GUIXMLPrefs").blank_passwords && $(document).data("GUIXMLPrefs").blank_passwords == "false")
				{
					password.addClass("ignoreBlank").attr("valtype", "userPass").validateNow();
				}
				else
				{
					password.attr("valtype", "required,userPass");
				}
			}
		}
		$("#email", dataPanel).closest("fieldset").removeClass("inheritSet");
		userManager.data.setInheritPropertyOfSection($("#email", dataPanel), "email", !panel);
	}

	var vfsLinks = $("#vfsLinks", dataPanel).empty();
	if(userInfo.user.linked_vfs)
	{
		userManager.UI.multiOptionControlDataBind(userInfo.user
		, "linked_vfs"
		, vfsLinks
		, function(curItem){
				var vfsLink = userManager.methods.decodeXML(curItem);
				return $("<li class='ui-widget-content' link='" + vfsLink + "'>"+vfsLink+"</li>");
			}
		, !panel);
	}

	if(!panel)
	{
		userManager.data.setInheritPropertyOfSection(vfsLinks, "linked_vfs", true);
		var vfsItemList = $("#vfsItemList", dataPanel);
		var vfsItemsListingAndOptions = $("#vfsItemsListingAndOptions", dataPanel).removeClass("inheritSet");
		userManager.data.setInheritPropertyOfSection(vfsItemList, "root_dir", true);
		vfsItemsListingAndOptions.find("td.checkboxArea").find("input").trigger("change");
	}
	if(dataPanel.find("#serverDirSelectList").length>0)
	{
		panelSetup.serverDirSelectList.trigger("change.local");
	}
	userManager.UI.panelsPostbindEvent(dataPanel);
}

panelSetup.bindEvents = function()
{
	userManager.UI.togglePanels(panelSetup._panel);

	panelSetup.serverDirSelectList.combobox();

	var fieldPropertiesDialog = $("#fieldPropertiesDialog").dialog({
		autoOpen: false,
		height: 300,
		width: 600,
		modal: true,
		resizable: false,
		closeOnEscape: false,
		buttons: {
			"Cancel" : function(){
				$(this).dialog( "close" );
			},
			"Ok": function() {
				var that = $(this);
				function continueProcess()
				{
					var name = $("#itemProperty_option_name_static", fieldPropertiesDialog).val();
					var newName = $("#itemProperty_option_name", fieldPropertiesDialog).val();
					var url = $("#itemProperty_option_url", fieldPropertiesDialog).val();
					$("#item_option_itemType", fieldPropertiesDialog).trigger("change");
					if(userManager.methods.hasSpecialCharacters(newName, userManager.notAllowedCharsInDirName))
					{
						jAlert("You can not use these characters in name : \"" + userManager.notAllowedCharsInDirName + "\"", "Invalid name", function(){
							$("#itemProperty_option_name", fieldPropertiesDialog).focus();
						});
						return false;
					}
					var as2Selected = $("#item_option_itemType", fieldPropertiesDialog).val() == "custom";
					var excludeItems = fieldPropertiesDialog.find("*[_name*='as2']");
					if(!as2Selected)
					{
						excludeItems = excludeItems.addClass("excludeXML");
					}
					var S3Selected = $("#item_option_itemType", fieldPropertiesDialog).val() == "s3";
					if(S3Selected)
					{
						fieldPropertiesDialog.find(".privateOptions").find("input").addClass("excludeXML");
						fieldPropertiesDialog.find("*[name*='s3']").removeClass("excludeXML");
					}
					else
					{
						fieldPropertiesDialog.find("*[name*='s3']").addClass("excludeXML");
						fieldPropertiesDialog.find(".privateOptions").find("input").removeClass("excludeXML");
					}
					var itemProperties = userManager.data.buildXMLToSubmitForm(fieldPropertiesDialog, true, "_name");
					if(excludeItems) excludeItems.removeClass("excludeXML");
					var type = "DIR";
					if(url.lastIndexOf("/") != url.length - 1 && url.lastIndexOf("\\") != url.length - 1)
						type = "FILE";
					var itemPropertiesJSON = $.xml2json("<item>" +  unescape(itemProperties) + "<type>" + type + "</type>" + "</item>");
					panelSetup.updateOrAddVFSPropertiesForItemByName(name, itemPropertiesJSON);
					panelSetup.userDirSelectList.trigger("change");
					panelSetup._panel.trigger("changed");
					that.dialog("close");
				}
				if(fieldPropertiesDialog.find(".hasPendingCall").length>0)
				{
					window.pendingEncryptionCall = function(){
						continueProcess();
					};
				}
				else
				{
					continueProcess();
				}
			}
		},
		beforeClose : function(){
			return true;
		},
		open: function(){
			panelSetup.showHideItemPropertiesSettings();
			$("a.serverFilePickButton", fieldPropertiesDialog).each(function(){
				$(this).unbind().click(function(){
					var curElem = $(this);
					curElem.crushFtpVFSBrowserPopup({
						type : curElem.attr("PickType") || 'dir',
						callback : function(selectedPath){
							$("#" + curElem.attr("rel"), fieldPropertiesDialog).val(selectedPath).trigger("change");
						}
					});
					return false;
				});
			});
		}
	});

	$("#item_option_itemType", fieldPropertiesDialog).change(function(){
		panelSetup.showHideItemPropertiesSettings();
		panelSetup.buildPropertiesURL();
	});

	fieldPropertiesDialog.find("#itemProperty_option_user_name, #itemProperty_option_password, #itemProperty_option_secretKeyID, #itemProperty_option_secretKey").bind("textchange", function(){
		panelSetup.buildPropertiesURL();
	});

	/*Encryption settings for item*/
	var fieldAdvancedDialog = $("#fieldAdvancedDialog").dialog({
		autoOpen: false,
		height: 600,
		width: 800,
		modal: true,
		resizable: true,
		closeOnEscape: false,
		buttons: {
			"Cancel" : function(){
				$(this).dialog( "close" );
			},
			"Ok": function() {
				var isChanged = fieldAdvancedDialog.attr("isChanged");
				if(isChanged == "true")
				{
					var encryption = {};
					fieldAdvancedDialog.find(".encryption").find("input:checked, input[type='text'], input[type='password']").each(function(){
						var val = $(this).val();
						if($(this).is(":checked"))
						{
							val = "true";
						}
						if(val.length>0)
							encryption[$(this).attr("_name")]= val;
					});
					var sync = {};
					fieldAdvancedDialog.find(".sync").find("input:checked, input[type='text'], input[type='password']").each(function(){
						var val = $(this).val();
						if($(this).is(":checked"))
						{
							val = "true";
						}
						if(val.length>0)
							sync[$(this).attr("_name")]= val;
					});
					$("#advancedVFSOptions", panelSetup._panel).data("privs", {"encryption":encryption, "sync":sync});
					$("#privsOptions", panelSetup._panel).find("input:first").trigger("change");
					panelSetup._panel.trigger("changed");
				}
				$(this).dialog("close");
			}
		},
		beforeClose : function(){
			return true;
		},
		open: function(){
			fieldAdvancedDialog.find("#advancedSettingsTabs").tabs({selected:0});
			$("a.serverFilePickButton", fieldAdvancedDialog).each(function(){
				$(this).click(function(){
					var curElem = $(this);
					curElem.crushFtpVFSBrowserPopup({
						type : curElem.attr("PickType") || 'dir',
						callback : function(selectedPath){
							$("#" + curElem.attr("rel"), fieldAdvancedDialog).val(selectedPath).trigger("change");
						}
					});
					return false;
				});
			});
		}
	});

	fieldAdvancedDialog.find("input").change(function(){
		fieldAdvancedDialog.attr("isChanged", true);
	});

	$("#pgpEncryptionGenerateButton").unbind().click(function () {
		if ($("#pgpPivateKeyPathGenerate").val().indexOf(".key") < 0)
		{
			$("#pgpPivateKeyPathGenerate").val($("#pgpPivateKeyPathGenerate").val()+"private.key");
		}
		var obj = {
			command: "pgpGenerateKeyPair",
			pgpCommonNameGenerate: userManager.methods.htmlEncode($("#pgpCommonNameGenerate").val()),
			pgpKeySizeGenerate: $("#pgpKeySizeGenerate").val(),
			pgpKeyDaysGenerate: $("#pgpKeyDaysGenerate").val(),
			pgpPrivateKeyPasswordGenerate: userManager.methods.htmlEncode($("#pgpPrivateKeyPasswordGenerate").val()),
			pgpPivateKeyPathGenerate: userManager.methods.htmlEncode($("#pgpPivateKeyPathGenerate").val()),
			random: Math.random()
		};
		$.ajax({
			type: "POST",
			url: userManager.ajaxCallURL,
			data: obj,
			error: function (XMLHttpRequest, textStatus, errorThrown) {
				errorThrown = errorThrown || "pgpGenerateKeyPair failed";
				userManager.UI.growl("Error : ", errorThrown, true, true);
			},
			success: function (msg) {
				var responseText = msg;
				try {
					var response = msg.getElementsByTagName("response");
					response = userManager.data.getTextContent(response[0]).textContent;
					alert(response);
				} catch (ex) {}
			}
		});
		return false;
	});

	fieldAdvancedDialog.find("input[type='text']").bind("textchange", function(){
		fieldAdvancedDialog.attr("isChanged", true);
	});

	$(".checkboxArea>input[type='checkbox']", panelSetup._panel).change(function(){
		var curUserData = userManager.storage("currentUserInherited");
		if(!$(this).is(":checked"))
		{
			curUserData = {user: userManager.storage("currentUsersLowerLevelsData")};
			$(this).closest("fieldset").addClass("inheritSet");
		}
		else
			$(this).closest("fieldset").removeClass("inheritSet");
		if($(this).attr("vfsArea") == "yes")
		{
			if(!$(this).is(":checked"))
			{
				panelSetup.vfsItemsDirList.empty();
				panelSetup.userDirSelectList.val("/");
				panelSetup.loadUser = $(this).closest("fieldset").find("legend").text();
				$("#root_dir", panelSettings._panel).addClass("excludeXML");
			}
			else
			{
				$("#root_dir", panelSettings._panel).removeClass("excludeXML");
				panelSetup.loadUser = false;
			}
		}
		if(!$(this).closest("fieldset").hasClass("notInheritable"))
			panelSetup.bindData(curUserData, false, $(this).closest("fieldset"));
	});

	$("#account_enabled", panelSetup._panel).change(function(){
		var max_logins = panelRestrictions._panel.find("#max_logins");
		if(max_logins && max_logins.length>0)
		{
			userManager.UI.checkUnchekInput(max_logins.closest("fieldset").find(".checkboxArea").find("input[type='checkbox']"), true).trigger("change");
			if(!$(this).is(":checked"))
			{
				max_logins.val("-1").trigger("change");
			}
			else
			{
				max_logins.val("0").trigger("change");
			}
		}
	});

	$("#revealPassword", panelSetup._panel).unbind("dblclick").bind("dblclick", function(){
		jAlert("Selected password is : " + $("#password", panelSetup._panel).val(), "Password");
	});

	var passwordGeneratePanel = $("#passwordGeneratePanel");
	$("#generateRandomPass", panelSetup._panel).unbind().click(function () {
		var passwords = [];
		var maxChars = $(document).data("GUIXMLPrefs").random_password_length || 8;
		passwords.push(userManager.methods.generateRandomPassword(maxChars));

		var minNumeric = $(document).data("GUIXMLPrefs").min_password_numbers || 0;
		var minLower = $(document).data("GUIXMLPrefs").min_password_lowers || 0;
		var minUpper = $(document).data("GUIXMLPrefs").min_password_uppers || 0;
		var minSpecial = $(document).data("GUIXMLPrefs").min_password_specials || 0;

		if(minNumeric>0 || minLower>0 || minUpper>0 || minSpecial>0)
		{
			passwords = [];
			if(minNumeric>0)
			{
				passwords.push(userManager.methods.generateRandomPassword(minNumeric, true));
			}
			if(minLower>0)
			{
				passwords.push(userManager.methods.generateRandomPassword(minLower, false, 'abcdefghijklmnopqrstuvwxyz'));
			}
			if(minUpper>0)
			{
				passwords.push(userManager.methods.generateRandomPassword(minUpper, false, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'));
			}
			if(minSpecial>0)
			{
				passwords.push(userManager.methods.generateRandomPassword(minSpecial, false, userManager.specialCharactersInUserPass));
			}
		}
		passwords.sort(function(a,b){ return( parseInt( Math.random()*10 ) %2 );});
		var pass = passwords.join("");
		pass = pass.shuffle();
		if(pass.length>maxChars)
		{
			pass = pass.substr(0, maxChars);
		}
		else if(pass.length<maxChars)
		{
			pass += userManager.methods.generateRandomPassword(maxChars - pass.length, true);
		}
		pass = pass.shuffle();
		$("#generated_password", panelSetup._panel).val(pass);
		passwordGeneratePanel.show();
		return false;
	});
	passwordGeneratePanel.hide();
	passwordGeneratePanel.find("a#usePassword").unbind().click(function () {
		$("#password",  panelSetup._panel).val($("#generated_password", passwordGeneratePanel).val()).effect("highlight", {}, 1500);
		return false;
	});
	passwordGeneratePanel.find("a#cancelPassword").unbind().click(function () {
		passwordGeneratePanel.hide();
		return false;
	});

	var vfsLinks = $("#vfsLinks", panelSetup._panel);
	$("a#addVFSLink", panelSetup._panel).click(function(evt, controlData, control){
		var users = userManager.storage("users");
		var userList = [];
		for(var i in users)
		{
			if(users[i].text)
				userList.push(users[i].text);
		}
		jPrompt("Choose a user to link to their VFS : ", false, "Link to User's VFS", function(value){
			var user = value;
			if(user != null)
			{
				userManager.UI.addItem(vfsLinks
					, $("<li class='ui-widget-content' user='" + user + "'>" + user + "</li>")
					, user);
				panelSetup._panel.trigger("changed");
			}
		}, userList);
		return false;
	});

	$("a#removeVFSLink", panelSetup._panel).click(function(){
		userManager.UI.removeItem(vfsLinks);
		panelSetup._panel.trigger("changed");
		return false;
	});

	panelSetup.vfsItemsDirList.unbind("onSelect").bind("onSelect"
		, function(evt, list, selected){
			if($(selected).is(".uplevelLink"))
			{
				evt.stopPropagation();
				evt.preventDefault();
				panelSetup.serverDirSelected($(selected), true);
			}
			else
			{
				panelSetup.vfsItemSelected(list, selected);
			}
		return false;
	});

	panelSetup.vfsItemsDirList.find("li").live("dblclick", function(){
		// Remove selection range, it messes up UI as all the text came between selection highlights in native browser selection manner
		if (window.getSelection) // Modern Browsers
		{
			var selection = window.getSelection();
			if (selection.removeAllRanges) {
				selection.removeAllRanges();
			}
		}
		if (document.getSelection) // IE
		{
			var selection = document.getSelection();
			if (selection.removeAllRanges) {
				selection.removeAllRanges();
			}
		}
		panelSetup.serverDirSelected($(this), true);
		return false;
	});

	panelSetup.vfsItemsDirList.parent().droppable({
		activeClass: "ui-state-default",
		hoverClass: "ui-state-hover",
		accept: ".serverItem",
		drop: function( event, ui ) {
			var curPath = panelSetup.userDirSelectList.val();
			if(panelSetup.checkIfCurrentDirIsVFSItem(curPath))
			{
				panelSetup.vfsItemsDirList.append(ui.draggable.clone().removeClass("ui-draggable"));
				panelSetup.vfsItemsDirList.find("li.ui-widget-header").removeClass("ui-selected, ui-widget-header");
				var selected = panelSetup.vfsItemsDirList.find("li:last").addClass("ui-selected, ui-widget-header");
				panelSetup.vfsItemSelected(false, selected);
				var newPath = curPath + selected.attr("name").replace(/\:/g, "");
				if(selected.attr("_type").toLowerCase() == "dir")
				{
					newPath += "/";
				}
				if(typeof newPath == "undefined") newPath = "/";
				panelSetup.updatePrivsForSelectedItem(newPath.toUpperCase());
				var itemName = selected.attr("name").replace(/\:/g, "");
				selected.attr("name", itemName);
				var url = selected.text();
				if(url)
				{
					url = unescape(panelSetup.serverDirSelectList.val()) + url;
					if(selected.attr("_type").toLowerCase() == "dir")
					{
						 url += "/";
					}
					url = url.replace("//", "/");
				}
				if(url.indexOf("//") != 0 && url.indexOf("\\") != 0)
				{
					url = selected.attr("curPath");
					if(selected.attr("_type").toLowerCase() == "dir")
					{
						 url += "/";
					}
				}
				var itemPropertiesJSON = {
					name : userManager.methods.htmlEncode(itemName),
					type : selected.attr("_type"),
					path : curPath,
					url : "FILE:/"+ url
				};
				panelSetup.lastDroppedItem = newPath;
				panelSetup.updateOrAddVFSPropertiesForItemByName(itemName, itemPropertiesJSON);
				panelSetup.userDirSelectList.trigger("change");
				panelSetup._panel.trigger("changed");
			}
			else
			{
				userManager.UI.growl("Message : ", "Items can not be dropped here", true, 3000);
			}
		}
	});

	panelSetup.userDirSelectList.unbind().change(function(){
		$(this).find("option:selected").nextAll("option").remove();
		panelSetup.bindServerDirsToBrowse(unescape($(this).val()), true, true);
		return false;
	});

	panelSetup._panel.find("#refreshUserListing").unbind().click(function(){
		panelSetup.userDirSelectList.change();
		return false;
	});

	panelSetup.serverDirBrowsePanel.unbind("onSelect").bind("onSelect", function(evt, list, selected){
		if($(selected).is(".uplevelLink"))
		{
			evt.stopPropagation();
			evt.preventDefault();
			panelSetup.serverDirSelected($(selected));
		}
		else
		{
			panelSetup.showHideServerOperationButtons();
		}
		return false;
	});

	panelSetup.serverDirBrowsePanel.find("li").live("click", function(){
		if($(this).is(".uplevelLink"))
		{
			panelSetup.serverDirSelected($(this));
		}
		else
		{
			$(this).parent().find(".ui-widget-header").removeClass("ui-selected, ui-widget-header");
			$(this).addClass("ui-selected, ui-widget-header");
			panelSetup.showHideServerOperationButtons();
		}
		return false;
	});

	panelSetup.serverDirBrowsePanel.find("li").live("dblclick", function(){
		panelSetup.serverDirSelected($(this));
		return false;
	});

	panelSetup.serverDirSelectList.unbind("change.local").bind("change.local", function(){
		$(this).find("option:selected").nextAll("option").remove();
		panelSetup.bindServerDirsToBrowse(unescape($(this).val()), true);
		return false;
	});

	panelSetup._panel.find("#refreshServerListing").unbind().click(function(){
		panelSetup.serverDirSelectList.trigger("change.local");
		return false;
	});

	$("a#inheritFromRootVFSOptions", panelSetup._panel).click(function(){
		var selected = $("li.ui-widget-header", panelSetup.vfsItemsDirList);
		if(selected.length>0)
		{
			var vfsOptions = $("#vfsOptions", panelSetup._panel);
			panelSetup.updateItemPrivs(selected.data("hrefPath"), "", true);
			panelSetup.vfsItemSelected(false, selected);
			$("#privsOptions", vfsOptions).find(".ui-state-active").removeClass("ui-state-active");
			panelSetup._panel.trigger("changed");
		}
		return false;
	});

	function updatePrivs(changedItem)
	{
		if(!changedItem)return;
		var selectedDir = $("li.ui-widget-header", panelSetup.vfsItemsDirList);
		if(selectedDir && selectedDir.length>0)
		{
			var vfsOptions = $("#vfsOptions", panelSetup._panel);
			var name = unescape(selectedDir.attr("name"));
			var curPath = panelSetup.userDirSelectList.val();
			var matchedElem = panelSetup.checkIfCurrentDirIsVFSItem(curPath, name);
			if(changedItem.is("#setup_invisible:checked"))
			{
				jConfirm("This will make the item invisible, Are you sure you want to do that?", "Confirm", function(value){
					userManager.UI.checkUnchekInput(changedItem, value);
					panelSetup.updatePrivsForSelectedItem();
					$("#privsOptions", vfsOptions).removeClass("ui-priority-secondary");
					$("#privsOptions", vfsOptions).find(".ui-state-active").removeClass("ui-state-active");
				});
			}
			else if(changedItem.is("#setup_write:checked") && matchedElem && matchedElem.url.length == 0)
			{
				jAlert("Can not allow write access to virtual folder.", "Error", function(){
					userManager.UI.checkUnchekInput(changedItem, false);
					panelSetup.updatePrivsForSelectedItem();
					$("#privsOptions", vfsOptions).removeClass("ui-priority-secondary");
					$("#privsOptions", vfsOptions).find(".ui-state-active").removeClass("ui-state-active");
				});
			}
			else if(changedItem.is("#setup_makedir:checked") && matchedElem && matchedElem.url.length == 0)
			{
				jAlert("Can not allow make directory access to virtual folder.", "Error", function(){
					userManager.UI.checkUnchekInput(changedItem, false);
					panelSetup.updatePrivsForSelectedItem();
					$("#privsOptions", vfsOptions).removeClass("ui-priority-secondary");
					$("#privsOptions", vfsOptions).find(".ui-state-active").removeClass("ui-state-active");
				});
			}
			else
			{
				panelSetup.updatePrivsForSelectedItem();
				$("#privsOptions", vfsOptions).removeClass("ui-priority-secondary");
				$("#privsOptions", vfsOptions).find(".ui-state-active").removeClass("ui-state-active");
			}
		}
		else
		{
			$(changedItem).parent().next().removeClass("ui-state-active").removeClass("hover");
			userManager.UI.checkUnchekInput($(changedItem).val("").text(""), false);
		}
	}

	$("#vfsOptions", panelSetup._panel).find("input[type='checkbox'], textarea").bind("change", function(){
		updatePrivs($(this));
	});

	$("#vfsOptions", panelSetup._panel).find("input[type='text'], textarea").bind("textchange", function(){
		updatePrivs($(this));
	});

	panelSetup.showHideVFSOperationButtons();

	panelSetup.vfsItemOperations.find("li.properties").find("a").click(function(){
		if($(this).closest("li").hasClass("ui-state-disabled"))return false;
		var userItemSelected = panelSetup.vfsItemsDirList.find("li.ui-widget-header");
		if(userItemSelected.length>0)
		{
			panelSetup.showVFSItemProperties(userItemSelected);
		}
		return false;
	});

	panelSetup._panel.find("a#advancedVFSOptions").click(function(){
		var userItemSelected = panelSetup.vfsItemsDirList.find("li.ui-widget-header");
		if(userItemSelected.length>0)
		{
			var fieldAdvancedDialog = $("#fieldAdvancedDialog");
			fieldAdvancedDialog.clearForm();
			fieldAdvancedDialog.find("#pgpKeySizeGenerate").val("2048");
			fieldAdvancedDialog.find("#pgpKeyDaysGenerate").val("365");
			panelSetup.showVFSItemEncryption(userItemSelected);
		}
		return false;
	});

	panelSetup.vfsItemOperations.find("li.newFolder").find("a").click(function(){
		if($(this).closest("li").hasClass("ui-state-disabled"))return false;
		jPrompt("Enter a directory name : ", false, "Directory Name", function(value){
			var name = value;
			if(name != null)
			{
				var itemPropertiesJSON = {
					name : name,
					path : panelSetup.userDirSelectList.val(),
					type : "DIR",
					url : ""
				};
				panelSetup.updateOrAddVFSPropertiesForItemByName(name, itemPropertiesJSON);
				panelSetup.userDirSelectList.trigger("change");
				panelSetup._panel.trigger("changed");
			}
		}, false, false, {
			messageToAppend : "<br />(This is a virtual directory, you cannot upload to it.)<br />"
		});
		return false;
	});

	panelSetup.vfsItemOperations.find("li.newItem").find("a").click(function(){
		if($(this).closest("li").hasClass("ui-state-disabled"))return false;
		panelSetup.showVFSItemProperties();
		panelSetup._panel.trigger("changed");
		return false;
	});

	panelSetup.vfsItemOperations.find("li.rename").find("a").click(function(){
		if($(this).closest("li").hasClass("ui-state-disabled"))return false;
		var userItemSelected = panelSetup.vfsItemsDirList.find("li.ui-widget-header");
		if(userItemSelected.length>0)
		{
			panelSetup.renameVFSItem(userItemSelected);
		}
		return false;
	});

	panelSetup.vfsItemOperations.find("li.remove").find("a").click(function(){
		if($(this).closest("li").hasClass("ui-state-disabled"))return false;
		var userItemSelected = panelSetup.vfsItemsDirList.find("li.ui-widget-header");
		if(userItemSelected.length>0)
		{
			panelSetup.removeVFSItem(userItemSelected);
		}
		return false;
	});

	$("a#sendPassEmail", panelSetup._panel).click(function(){
		userManager.methods.performServerAction($(this),
			{
				command : "sendPassEmail",
				serverGroup : $("#userConnectionGroups").val() || "MainUsers",
				user_name : $("#user_name", panelSetup._panel).val(),
				user_pass : $("#password", panelSetup._panel).val(),
				user_email : $("#email", panelSetup._panel).val(),
				user_first_name : $("#first_name", panelSetup._panel).val(),
				user_last_name : $("#last_name", panelSetup._panel).val()
			}
		, "Sending user information via email :");
		return false;
	});

	$("#vfsOptions", panelSetup._panel).find("input[type='text'],textarea").bind("focus", function(){
		var selected = $("li.ui-widget-header", panelSetup.vfsItemsDirList);
		if(selected.length==0)
		{
			$(this).blur();
			return false;
		}
	});

	panelSetup.serverItemOperations.find("li.newFolder").find("a").click(function(){
		if($(this).closest("li").hasClass("ui-state-disabled"))return false;
		panelSetup.addServerItem();
		return false;
	});

	panelSetup.serverItemOperations.find("li.rename").find("a").click(function(){
		if($(this).closest("li").hasClass("ui-state-disabled"))return false;
		var itemSelected = panelSetup.serverDirBrowsePanel.find("li.ui-widget-header");
		if(itemSelected.length>0)
		{
			panelSetup.renameServerItem(itemSelected);
		}
		return false;
	});

	panelSetup.serverItemOperations.find("li.remove").find("a").click(function(){
		if($(this).closest("li").hasClass("ui-state-disabled"))return false;
		var itemSelected = panelSetup.serverDirBrowsePanel.find("li.ui-widget-header");
		if(itemSelected.length>0)
		{
			panelSetup.removeServerItem(itemSelected);
		}
		return false;
	});
}

panelSetup.showHideServerOperationButtons = function()
{
	if(panelSetup.serverDirSelectList.val() == "/")
	{
		panelSetup.serverItemOperations.find("li").addClass("ui-state-disabled");
		return false;
	}
	else
	{
		panelSetup.serverItemOperations.find("li.newFolder").removeClass("ui-state-disabled");
	}
	var items = panelSetup.serverItemOperations.find("li.remove, li.rename").addClass("ui-state-disabled");
	var serverItemSelected = panelSetup.serverDirBrowsePanel.find("li.ui-widget-header");
	if(serverItemSelected.length>0)
	{
		items.removeClass("ui-state-disabled");
	}
}

panelSetup.showHideVFSOperationButtons = function()
{
	panelSetup.vfsItemOperations.find("li").addClass("ui-state-disabled");
	var userItemSelected = panelSetup.vfsItemsDirList.find("li.ui-widget-header");
	if(userItemSelected.length>0)
	{
		var name = unescape($(userItemSelected).attr("name"));
		var curPath = panelSetup.userDirSelectList.val();
		var matchedElem = panelSetup.checkIfCurrentDirIsVFSItem(curPath, name);
		if(matchedElem)
		{
			panelSetup.vfsItemOperations.find("li.remove, li.rename").removeClass("ui-state-disabled");
			if(matchedElem.url.length>0)
			{
				panelSetup.vfsItemOperations.find("li.properties").removeClass("ui-state-disabled");
			}
			else
			{
				panelSetup.vfsItemOperations.find("li.properties").addClass("ui-state-disabled");
			}
		}
	}
	var curPath = panelSetup.userDirSelectList.val();
	if(panelSetup.checkIfCurrentDirIsVFSItem(curPath))
	{
		panelSetup.vfsItemOperations.find("li.newFolder, li.newItem").removeClass("ui-state-disabled");
	}
}

panelSetup.updateOrAddVFSPropertiesForItemByName = function(name, properties)
{
	var matchedElem = panelSetup.updateVFSPropertiesForItemByName(name, properties)
	if(!matchedElem)
	{
		var currentUser = userManager.storage("currentUser");
		if(!currentUser.vfs_items)
		{
			currentUser.vfs_items = {};
		}
		if(!currentUser.vfs_items.vfs_items_subitem)
		{
			currentUser.vfs_items.vfs_items_subitem = [];
		}
		userManager.methods.rebuildSubItems(currentUser.vfs_items, "vfs_items");
		currentUser.vfs_items.vfs_items_subitem.push({
			vfs_items_subitem_subitem :  properties
		});
	}
}

panelSetup.updateVFSPropertiesForItemByName = function(name, properties, remove)
{
	var matchedElem = false;
	var currentUser = userManager.storage("currentUser");
	if(currentUser.vfs_items && currentUser.vfs_items.vfs_items_subitem)
	{
		userManager.methods.rebuildSubItems(currentUser.vfs_items, "vfs_items");
		var curVFSItems = currentUser.vfs_items.vfs_items_subitem;
		for(var i=0;i<curVFSItems.length;i++)
		{
			var curItem = curVFSItems[i];
			if(curItem.vfs_items_subitem_subitem && curItem.vfs_items_subitem_subitem.name)
			{
				var itemName = unescape(curItem.vfs_items_subitem_subitem.name);
				if(name == itemName)
				{
					if(remove)
					{
						matchedElem = curItem.vfs_items_subitem_subitem;
						currentUser.vfs_items.vfs_items_subitem.remove(i);
					}
					else
					{
						curItem.vfs_items_subitem_subitem = properties;
						var subItem = curItem.vfs_items_subitem_subitem;
						matchedElem = subItem;
					}
					i = curVFSItems.length;
				}
			}
		}
	}
	return matchedElem;
}

panelSetup.getVFSPropertiesForItemByName = function(name)
{
	var matchedElem = false;
	var currentUser = userManager.storage("currentUser");
	if(currentUser.vfs_items && currentUser.vfs_items.vfs_items_subitem)
	{
		userManager.methods.rebuildSubItems(currentUser.vfs_items, "vfs_items");
		var curVFSItems = currentUser.vfs_items.vfs_items_subitem;
		for(var i=0;i<curVFSItems.length;i++)
		{
			var curItem = curVFSItems[i];
			if(curItem.vfs_items_subitem_subitem)
			{
				var subItem = curItem.vfs_items_subitem_subitem;
				var itemName = userManager.methods.decodeXML(unescape(subItem.name));
				if(userManager.methods.decodeXML(unescape(name)) == itemName)
				{
					matchedElem = $.extend(true, {}, subItem);
					i = curVFSItems.length;
				}
			}
		}
	}
	return matchedElem;
}

panelSetup.checkIfCurrentDirIsVFSItem = function(path, name)
{
	if(unescape(path) == "/" && !name)return true;
	var matchedElem = false;
	var currentUser = userManager.storage("currentUser");
	if(currentUser.vfs_items && currentUser.vfs_items.vfs_items_subitem)
	{
		userManager.methods.rebuildSubItems(currentUser.vfs_items, "vfs_items");
		var curVFSItems = currentUser.vfs_items.vfs_items_subitem;
		for(var i=0;i<curVFSItems.length;i++)
		{
			var curItem = curVFSItems[i];
			if(curItem.vfs_items_subitem_subitem)
			{
				var subItem = curItem.vfs_items_subitem_subitem;
				var itemName = unescape(subItem.name);
				var itemPath = unescape(subItem.path);
				if(name)
				{
					if(userManager.methods.decodeXML(unescape(itemPath + itemName + "/")) == userManager.methods.decodeXML(unescape(path + name + "/")))
					{
						matchedElem = $.extend(true, {}, subItem);
						i = curVFSItems.length;
					}
				}
				else
				{
					if(userManager.methods.decodeXML(unescape(path)) == userManager.methods.decodeXML(unescape(itemPath + itemName + "/")) && subItem.url == "")
					{
						matchedElem = $.extend(true, {}, subItem);
						i = curVFSItems.length;
					}
				}
			}
		}
	}
	return matchedElem;
}

panelSetup.bindPropertiesWindowDataForSelectedItem = function(selected)
{
	var name = selected ? unescape(selected.attr("name")) : "";
	var matchedElem = selected ? panelSetup.getVFSPropertiesForItemByName(name) : {
		name : "",
		path : "/",
		type : "DIR",
		url : "FILE:/"
	};
	if(matchedElem)
	{
		var fieldPropertiesDialog = $("#fieldPropertiesDialog");
		var item_option_itemType = $("#item_option_itemType", fieldPropertiesDialog);
		fieldPropertiesDialog.clearForm();
		var url = matchedElem.url;
		url = unescape(url);
		var lowCaseURL = url.toLowerCase();
		if(lowCaseURL.indexOf("file:") == 0)
		{
			item_option_itemType.val("file");
		}
		else if(lowCaseURL.indexOf("ftp:") == 0)
		{
			item_option_itemType.val("ftp");
		}
		else if(lowCaseURL.indexOf("http:") == 0)
		{
			item_option_itemType.val("http");
		}
		else if(lowCaseURL.indexOf("https:") == 0)
		{
			item_option_itemType.val("https");
		}
		else if(lowCaseURL.indexOf("webdav:") == 0)
		{
			item_option_itemType.val("webdav");
		}
		else if(lowCaseURL.indexOf("webdavs:") == 0)
		{
			item_option_itemType.val("webdavs");
		}
		else if(lowCaseURL.indexOf("ftps:") == 0)
		{
			item_option_itemType.val("ftps");
		}
		else if(lowCaseURL.indexOf("sftp:") == 0)
		{
			item_option_itemType.val("sftp");
		}
		else if(lowCaseURL.indexOf("custom") == 0)
		{
			item_option_itemType.val("custom");
		}
		else if(lowCaseURL.indexOf("s3") == 0)
		{
			item_option_itemType.val("s3");
		}
		userManager.data.bindValuesFromJson(fieldPropertiesDialog, matchedElem, "_name", true);
		if(lowCaseURL.indexOf("s3") == 0)
		{
			$("#itemProperty_option_secretKeyID", fieldPropertiesDialog).trigger("textchange");
		}
		url = fieldPropertiesDialog.find("#itemProperty_option_url").val();
		if(url.indexOf("file:") != 0)
		{
			if(url.indexOf("://")>=0)
			{
				url = url.substr(url.indexOf("://") + 3, url.length);
				if(url.indexOf("@")>=0)
				{
					url = url.substr(0, url.indexOf("@"));
					if(url && url.indexOf(":")>=0)
					{
						var cred = url.split(":");
						if(cred.length>0)
						{
							$("#itemProperty_option_user_name", fieldPropertiesDialog).val(cred[0]);
						}
						if(cred.length>1)
						{
							$("#itemProperty_option_password", fieldPropertiesDialog).val(cred[1]);
						}
					}
				}
			}
		}
	}
}

panelSetup.bindEncryptionWindowDataForSelectedItem = function(selected)
{
	if(!selected)return;
	var fieldAdvancedDialog = $("#fieldAdvancedDialog");
	var vfsOptions = $("#vfsOptions", panelSetup._panel);
	var privs = $("#advancedVFSOptions", vfsOptions).data("privs");
	function bindPopupFields(panel, data)
	{
		var inputs = panel.find("input");
		for(var i in data)
		{
			var curPriv = data[i];
			if(curPriv)
			{
				inputs.each(function(){
					if($(this).attr("_name") == i)
					{
						if($(this).attr("type") == "checkbox")
						{
							userManager.UI.checkUnchekInput($(this), curPriv == "true");
						}
						else
						{
							$(this).val(unescape(curPriv));
						}
						return false;
					}
				});
			}
		}
	}

	var encryption = privs.encryption;
	if(encryption)
	{
		bindPopupFields(fieldAdvancedDialog.find(".encryption"), encryption);
	}

	var sync = privs.sync;
	if(sync)
	{
		bindPopupFields(fieldAdvancedDialog.find(".sync"), sync);
	}

	fieldAdvancedDialog.attr("isChanged", false);
}

panelSetup.showHideItemPropertiesSettings = function()
{
	var fieldPropertiesDialog = $("#fieldPropertiesDialog");
	var ftpCredentials = $(".ftpCredentials", fieldPropertiesDialog).show();
	var s3Credentials = $(".s3Credentials", fieldPropertiesDialog).hide();
	var HAOptions = $(".HAOptions", fieldPropertiesDialog).show();
	var privateOptions = $(".privateOptions", fieldPropertiesDialog).hide();
	var as2Options = $(".as2Options", fieldPropertiesDialog).hide();
	fieldPropertiesDialog.dialog({
		height: 300
	});
	var item_option_itemType = $("#item_option_itemType", fieldPropertiesDialog).val();
	if(item_option_itemType == "file")
	{
		ftpCredentials.hide();
		HAOptions.hide();
		fieldPropertiesDialog.dialog({
			height: 250
		});
	}
	if(item_option_itemType == "s3")
	{
		ftpCredentials.hide();
		s3Credentials.show();
		fieldPropertiesDialog.dialog({
			height: 400
		});
	}
	if(item_option_itemType == "custom")
	{
		as2Options.show();
		HAOptions.hide();
		fieldPropertiesDialog.dialog({
			height: 650
		});
	}
	if(item_option_itemType == "sftp")
	{
		privateOptions.show();
		fieldPropertiesDialog.dialog({
			height: 400
		});
	}
}

panelSetup.buildPropertiesURL = function()
{
	var fieldPropertiesDialog = $("#fieldPropertiesDialog");
	var itemProperty_option_url = fieldPropertiesDialog.find("#itemProperty_option_url");
	var curUrl = itemProperty_option_url.val();
	var staticURL = curUrl;//fieldPropertiesDialog.find("#itemProperty_option_url_static").val();
	if(staticURL.indexOf("://")>=0)
	{
		staticURL = staticURL.substr(staticURL.indexOf("://") + 3, staticURL.length);
		if(staticURL.indexOf("@")>=0)
		{
			staticURL = staticURL.substr(staticURL.indexOf("@") + 1, staticURL.length);
		}
	}
	var item_option_itemType = $("#item_option_itemType", fieldPropertiesDialog).val();
	var fileSelected = item_option_itemType == "file";
	var ftpSelected = item_option_itemType == "ftp";

	var httpSelected = item_option_itemType == "http";
	var httpsSelected = item_option_itemType == "https";
	var webdavSelected = item_option_itemType == "webdav";
	var webdavsSelected = item_option_itemType == "webdavs";

	var ftpsSelected = item_option_itemType == "ftps";
	var sftpSelected = item_option_itemType == "sftp";
	var as2Selected = item_option_itemType == "custom";
	var s3Selected = item_option_itemType == "s3";

	function addUserPassToURL(url, protocol, addUP)
	{
		url = url.replace("s3.amazonaws.com/", "");
		if(addUP)
		{
			var userName = $("#itemProperty_option_user_name", fieldPropertiesDialog).val();
			var pass = $("#itemProperty_option_password", fieldPropertiesDialog).val();
			if(userName.length>0 || pass.length>0)
			{
				url = userName + ":" + pass + "@" + url;
			}
		}
		return protocol + url;
	}

	function addUserPassToURLS3(url, protocol)
	{
		url = url.replace("s3.amazonaws.com/", "");
		var userName = $("#itemProperty_option_secretKeyID", fieldPropertiesDialog).val();
		var pass = $("#itemProperty_option_secretKey", fieldPropertiesDialog).val();
		if(userName.length>0 || pass.length>0)
		{
			url = userName + ":" + pass + "@s3.amazonaws.com/" + url;
		}
		else
			url = "s3.amazonaws.com/" + url;
		return protocol + url;
	}

	if(fileSelected)
	{
		itemProperty_option_url.val(addUserPassToURL(staticURL, "FILE://"));
	}
	else if(ftpSelected)
	{
		itemProperty_option_url.val(addUserPassToURL(staticURL, "FTP://", true));
	}
	else if(httpSelected)
	{
		itemProperty_option_url.val(addUserPassToURL(staticURL, "HTTP://", true));
	}
	else if(httpsSelected)
	{
		itemProperty_option_url.val(addUserPassToURL(staticURL, "HTTPS://", true));
	}
	else if(webdavSelected)
	{
		itemProperty_option_url.val(addUserPassToURL(staticURL, "WEBDAV://", true));
	}
	else if(webdavsSelected)
	{
		itemProperty_option_url.val(addUserPassToURL(staticURL, "WEBDAVS://", true));
	}
	else if(ftpsSelected)
	{
		itemProperty_option_url.val(addUserPassToURL(staticURL, "FTPS://", true));
	}
	else if(sftpSelected)
	{
		itemProperty_option_url.val(addUserPassToURL(staticURL, "SFTP://", true));
	}
	else if(as2Selected)
	{
		itemProperty_option_url.val(addUserPassToURL(staticURL, "CUSTOM_crushftp.server.VFS_AS2://", true));
	}
	else if(s3Selected)
	{
		itemProperty_option_url.val(addUserPassToURLS3(staticURL, "s3://"));
	}
}

panelSetup.bindContextMenu = function()
{
	$("li", panelSetup.vfsItemsDirList).contextMenu({
			menu: "vfsItemContext"
		},
		function(action, el, pos) {
		if(action == "properties")
		{
			panelSetup.showVFSItemProperties(el);
		}
		else if(action == "rename")
		{
			panelSetup.renameVFSItem(el);
		}
		else if(action == "remove")
		{
			panelSetup.removeVFSItem(el);
		}
	}).bind("onBeforeContextMenu", function(){
		var name = unescape($(this).attr("name"));
		var curPath = panelSetup.userDirSelectList.val();
		var matchedElem = panelSetup.checkIfCurrentDirIsVFSItem(curPath, name);
		if(matchedElem)
		{
			$("#vfsItemContext").find(".rename, .remove").removeClass("ui-state-disabled");
			if(matchedElem.url.length>0)
			{
				$("#vfsItemContext").find(".properties").removeClass("ui-state-disabled");
			}
			else
			{
				$("#vfsItemContext").find(".properties").addClass("ui-state-disabled");
			}
		}
		else
		{
			$("#vfsItemContext").find(".properties, .rename, .remove").addClass("ui-state-disabled");
		}
	});
}

panelSetup.showVFSItemProperties = function(selected)
{
	panelSetup.bindPropertiesWindowDataForSelectedItem(selected);
	$("#fieldPropertiesDialog").form().dialog("open");
}

panelSetup.showVFSItemEncryption = function(selected)
{
	panelSetup.bindEncryptionWindowDataForSelectedItem(selected);
	$("#fieldAdvancedDialog").form().dialog("open");
}

panelSetup.renameVFSItem = function(selected)
{
	if(selected)
	{
		var currentUser = userManager.storage("currentUser");
		var curVFSItems = false;
		if(currentUser.vfs_items && currentUser.vfs_items.vfs_items_subitem)
		{
			userManager.methods.rebuildSubItems(currentUser.vfs_items, "vfs_items");
			 curVFSItems = currentUser.vfs_items.vfs_items_subitem;
		}
		var curPrivs = userManager.storage("currentUserDirPrivs") || new Object();
		function renameItem(oldName, newName, path, newPath)
		{
			for(var i=0;i<curVFSItems.length;i++)
			{
				var curItem = curVFSItems[i];
				if(curItem.vfs_items_subitem_subitem)
				{
					var subItem = curItem.vfs_items_subitem_subitem;
					var itemName = userManager.methods.decodeXML(unescape(subItem.name));
					if(oldName)
					{
						if(userManager.methods.decodeXML(unescape(oldName)) == itemName)
						{
							subItem.name = newName;
							curVFSItems[i].vfs_items_subitem_subitem = subItem;
							var curPath = subItem.path + oldName + "/";
							var changedPath = subItem.path + newName + "/";
							if(typeof curPath != "undefined" && typeof changedPath != "undefined")
							{
								var privs = curPrivs[curPath.toUpperCase()];
								if(privs)
								{
									delete curPrivs[curPath.toUpperCase()];
									curPrivs[changedPath.toUpperCase()] = privs;
								}
								renameItem(false, false, curPath, changedPath);
							}
						}
					}
					if(path)
					{
						if(unescape(subItem.path) == unescape(path))
						{
							var curPath = subItem.path + itemName + "/";
							subItem.path = newPath;
							curVFSItems[i].vfs_items_subitem_subitem = subItem;
							var changedPath = subItem.path + itemName + "/";
							if(typeof curPath != "undefined" && typeof changedPath != "undefined")
							{
								var privs = curPrivs[curPath.toUpperCase()];
								if(privs)
								{
									delete curPrivs[curPath.toUpperCase()];
									curPrivs[changedPath.toUpperCase()] = privs;
								}
								renameItem(false, false, curPath, changedPath);
							}
						}
					}
					panelSetup._panel.trigger("changed");
				}
			}
		}

		var name = unescape(selected.attr("name"));
		var matchedElem = panelSetup.getVFSPropertiesForItemByName(name);
		if(matchedElem)
		{
			function renamePrompt(name)
			{
				jPrompt("Rename item : ", name, "Rename", function(value){
					var newName = value;
					if(newName != null)
					{
						if(userManager.methods.hasSpecialCharacters(newName, userManager.notAllowedCharsInDirName))
						{
							jAlert("You can not use these characters in name : " + userManager.notAllowedCharsInDirName, "Invalid name", function(){
								renamePrompt(newName);
							});
						}
						else
						{
							renameItem(name, newName);
							panelSetup.userDirSelectList.trigger("change");
						}
						panelSetup._panel.trigger("changed");
					}
				});
			}
			renamePrompt(name);
		}
	}
}

panelSetup.removeVFSItem = function(selected)
{
	if(selected)
	{
		var currentUser = userManager.storage("currentUser");
		var curVFSItems = false;
		if(currentUser.vfs_items && currentUser.vfs_items.vfs_items_subitem)
		{
			userManager.methods.rebuildSubItems(currentUser.vfs_items, "vfs_items");
			 curVFSItems = currentUser.vfs_items.vfs_items_subitem;
		}
		var curPrivs = userManager.storage("currentUserDirPrivs") || new Object();
		function deteleItem(name, path, isFile)
		{
			for(var i=0;i<curVFSItems.length;i++)
			{
				var curItem = curVFSItems[i];
				if(curItem.vfs_items_subitem_subitem)
				{
					var subItem = curItem.vfs_items_subitem_subitem;
					var itemName = userManager.methods.decodeXML(unescape(subItem.name));
					if(name)
					{
						if(userManager.methods.decodeXML(unescape(name)) == itemName)
						{
							var changedPath = subItem.path + name;
							if(!isFile)
								changedPath = changedPath + "/";
							if(typeof changedPath != "undefined")
							{
								curVFSItems[i] = "##";
								delete curPrivs[changedPath.toUpperCase()];
								deteleItem(false, changedPath, isFile);
							}
						}
					}
					if(path)
					{
						if(unescape(subItem.path) == unescape(path))
						{
							var changedPath = subItem.path + itemName;
							if(!isFile)
								changedPath = changedPath + "/";
							if(typeof changedPath != "undefined")
							{
								curVFSItems[i] = "##";
								delete curPrivs[changedPath.toUpperCase()];
								deteleItem(false, changedPath, isFile);
							}
						}
					}
					panelSetup._panel.trigger("changed");
				}
			}
		}

		var name = unescape(selected.attr("name"));
		var matchedElem = panelSetup.getVFSPropertiesForItemByName(name);
		if(matchedElem)
		{
			jConfirm("Are you sure you want to delete this virtual item? <br/> <br/>" + name  + "<br/>", "Delete?", function(value){
				if(value)
				{
					deteleItem(name, false, matchedElem.type.toLowerCase() == "file");
					var _tempVFSItems = [];
					for(var i=0;i<curVFSItems.length;i++)
					{
						 if(curVFSItems[i].toString() != "##")
						 {
							_tempVFSItems.push($.extend(true, {},  curVFSItems[i]));
						 }
					}
					var vfsItems = $.extend(true, {},  _tempVFSItems);
					var vfsSubItems = [];
					for(var i in vfsItems)
					{
						if(vfsItems[i])
						{
							vfsSubItems.push(vfsItems[i]);
						}
					}
					currentUser.vfs_items.vfs_items_subitem = vfsSubItems;
					panelSetup.userDirSelectList.trigger("change");
					panelSetup._panel.trigger("changed");
				}
			});
		}
	}
}

panelSetup.addServerItem = function()
{
	function newFolderPrompt(name)
	{
		jPrompt("Folder Name : ", name, "Create New Folder", function(value){
			var newName = value;
			if(newName != null)
			{
				if(userManager.methods.hasSpecialCharacters(newName, userManager.notAllowedCharsInDirName))
				{
					jAlert("You can not use these characters in name : " + userManager.notAllowedCharsInDirName, "Invalid name", function(){
						newFolderPrompt(newName);
					});
				}
				else
				{
					var result = "OK";
					var resultItem = "response_status";
					var obj = {
						command: 'adminAction',
						action: 'newFolder',
						path : encodeURIComponent(unescape(panelSetup.serverDirSelectList.val())),
						name : newName
					};
					if(userManager.isUserLimitedAdmin)
					{
						obj = {
							command: 'makedir',
							path : encodeURIComponent(unescape(panelSetup.serverDirSelectList.val() + newName)),
							random: Math.random()
						};
						result = "";
						resultItem = "response";
					}
					userManager.data.serverRequest(obj,
					function(data){
						if(data)
						{
							var usersData = $.xml2json(data, false);
							if(usersData && typeof usersData[resultItem] != "undefined" && usersData[resultItem]== result)
							{
								panelSetup.serverDirSelectList.trigger("change.local");
								panelSetup._panel.trigger("changed");
							}
							else
							{
								userManager.UI.growl("Failure", $(data).text(), true, true);
							}
						}
					});
				}
			}
		});
	}
	newFolderPrompt();
}

panelSetup.renameServerItem = function(selected)
{
	if(selected)
	{
		function renamePrompt(name)
		{
			jPrompt("Rename item : ", name, "Rename", function(value){
				var newName = value;
				if(newName != null)
				{
					if(userManager.methods.hasSpecialCharacters(newName, userManager.notAllowedCharsInDirName))
					{
						jAlert("You can not use these characters in name : " + userManager.notAllowedCharsInDirName, "Invalid name", function(){
							renamePrompt(newName);
						});
					}
					else
					{
						var result = "OK";
						var resultItem = "response_status";
						var obj = {
							command: 'adminAction',
							action: 'renameItem',
							path : panelSetup.serverDirSelectList.val(),
							name : selected.attr("name"),
							newName : newName
						};
						if(userManager.isUserLimitedAdmin)
						{
							obj = {
								command: "rename",
								path: panelSetup.serverDirSelectList.val(),
								name1: selected.attr("name"),
								name2: encodeURIComponent(unescape(newName)),
								random: Math.random()
							};
							result = "";
							resultItem = "response";
						}
						userManager.data.serverRequest(obj,
						function(data){
							if(data)
							{
								var usersData = $.xml2json(data, false);
								if(usersData && typeof usersData[resultItem] != "undefined" && usersData[resultItem]== result)
								{
									panelSetup.serverDirSelectList.trigger("change.local");
									panelSetup._panel.trigger("changed");
								}
								else
								{
									userManager.UI.growl("Failure", $(data).text(), true, true);
								}
							}
						});
					}
				}
			});
		}
		renamePrompt(selected.attr("name"));
	}
}

panelSetup.removeServerItem = function(selected)
{
	if(selected)
	{
		var name = selected.attr("name");
		jConfirm("Are you sure you want to delete this item? <br/> <br/>" + name  + "<br/>", "Delete?", function(value){
			if(value)
			{
				var result = "OK";
				var resultItem = "response_status";
				var obj = {
					command: 'adminAction',
					action: 'deleteItem',
					path : panelSetup.serverDirSelectList.val(),
					name : selected.attr("name")
				};
				if(userManager.isUserLimitedAdmin)
				{
					obj = {
						command: "delete",
						names: encodeURIComponent(unescape(panelSetup.serverDirSelectList.val() + selected.attr("name"))),
						random: Math.random()
					};
					result = "";
					resultItem = "response";
				}
				userManager.data.serverRequest(obj,
				function(data){
					if(data)
					{
						var usersData = $.xml2json(data, false);
						if(usersData && typeof usersData[resultItem] != "undefined" && usersData[resultItem]== result)
						{
							panelSetup.serverDirSelectList.trigger("change.local");
							panelSetup._panel.trigger("changed");
						}
						else
						{
							userManager.UI.growl("Failure", $(data).text(), true, true);
						}
					}
				});
			}
		});
	}
}

panelSetup.buildDirPrivs = function()
{
	var currentUserXML = userManager.storage("currentUserXML");
	$(currentUserXML).find("permissions").find("item").each(function(){
		panelSetup.updateItemPrivs(unescape($(this).attr("name")), userManager.methods.decodeXML($(this).text()));
	});
	var currentUserDirPrivs = userManager.storage("currentUserDirPrivs");
	var defaultPrivs = $.extend(true, {}, currentUserDirPrivs);
	userManager.storage("currentUserDirPrivsDefault", defaultPrivs);
}

panelSetup.updatePrivsForSelectedItem = function(pathToUse)
{
	var selectedDir = $("li.ui-widget-header", panelSetup.vfsItemsDirList);
	if(selectedDir && selectedDir.length>0)
	{
		var privs = panelSetup.createPrivsForItem();
		pathToUse = pathToUse || selectedDir.data("hrefPath");
		panelSetup.updateItemPrivs(pathToUse, privs);
	}
}

panelSetup.updateItemPrivs = function(item, privs, remove)
{
	if(typeof item == "undefined") return;
	var curPrivs = userManager.storage("currentUserDirPrivs") || new Object();
	item = unescape(item).toUpperCase();
	if(remove)
	{
		var defaultPrivs = userManager.storage("currentUserDirPrivsDefault") || new Object();
		if(defaultPrivs[item])
		{
			curPrivs[item] = defaultPrivs[item].toString();
		}
		else if(curPrivs[item])
		{
			delete curPrivs[item];
		}
	}
	else
	{
		curPrivs[item] = privs;
	}
	userManager.storage("currentUserDirPrivs", curPrivs);
}

panelSetup.createPrivsForItem = function()
{
	var selectedDir = $("li.ui-widget-header", panelSetup.vfsItemsDirList);
	if(selectedDir && selectedDir.length>0)
	{
		var privs = "";
		var vfsOptions = $("#vfsOptions", panelSetup._panel);
		vfsOptions.find("input[id^='setup_']:checkbox:checked, #setup_quota, #advancedVFSOptions").each(function(){
			var id = $(this).attr("id");
			id = id.replace("setup_", "");
			if(id.indexOf("quota")==0)
			{
				var MB = $("#setup_quota", vfsOptions).val();
				if(userManager.methods.isNumeric(MB))
				{
					MB = parseInt(MB) * 1024 * 1024;
					privs += "("+id+ MB + ")";
				}
			}
			else if(id == "advancedVFSOptions")
			{
				var advancedPrivs = $(this).data("privs");
				var encryptPrivs = advancedPrivs.encryption;
				if(encryptPrivs)
				{
					for(var i in encryptPrivs)
					{
						privs += "(" + i + "=" + userManager.methods.htmlEncode(encryptPrivs[i]) + ")";
					}
				}
				var syncPrivs = advancedPrivs.sync;
				if(syncPrivs)
				{
					for(var i in syncPrivs)
					{
						privs += "(" + i + "=" + userManager.methods.htmlEncode(syncPrivs[i]) + ")";
					}
				}
			}
			else
			{
				privs += "("+id+")";
			}
		});
		var comment = $.trim($("#setup_comment", vfsOptions).val());
		if(comment && comment.length>0)
		{
			privs += "(comment"+comment+")";
		}
		return privs;
	}
	else
	{
		return false;
	}
}

panelSetup.vfsItemSelected = function(list, selected)
{
	panelSetup.showHideVFSOperationButtons();
	var vfsOptions = $("#vfsOptions", panelSetup._panel);
	vfsOptions.find("input[type='checkbox']").each(function(){
		userManager.UI.checkUnchekInput($(this), false);
		$("#privsOptions", vfsOptions).addClass("ui-priority-secondary");
	});
	$("#setup_quota", vfsOptions).val("");
	$("#setup_comment", vfsOptions).val("");
	var privs = selected.attr("privs");
	var curPrivs = userManager.storage("currentUserDirPrivs") || new Object();
	var path = selected.data("hrefPath");
	if(typeof path != "undefined")
	{
		var changedPrivs = curPrivs[path.toUpperCase()];
		if(changedPrivs)
		{
			privs = changedPrivs;
		}
	}
	if(privs && privs.length>0)
	{
		privs = privs.split(")(").join("|");
		privs = privs.substr(0, privs.lastIndexOf(")"));
		privs = privs.substr(1, privs.length);
		privs = privs.split("|");
		var isInherited = false;
		var encryption = {};
		var sync = {};
		for(var i=0; i<=privs.length;i++)
		{
			if(privs[i])
			{
				var lowerPriv = privs[i].toLowerCase();
				if(lowerPriv.indexOf("quota")==0)
				{
					var MB = parseInt(privs[i].replace("quota",""));
					if(MB)
					{
						$("#setup_quota", vfsOptions).val(MB/(1024*1024));
					}
				}
				else if(lowerPriv.indexOf("comment")==0)
				{
					$("#setup_comment", vfsOptions).val(privs[i].replace("comment",""));
				}
				else if(lowerPriv.indexOf("pgpdecryptupload") == 0)
				{
					encryption["pgpDecryptUpload"] = privs[i].replace("pgpDecryptUpload=","");
				}
				else if(lowerPriv.indexOf("pgpprivatekeyuploadpassword") == 0)
				{
					encryption["pgpPrivateKeyUploadPassword"] = privs[i].replace("pgpPrivateKeyUploadPassword=","");
				}
				else if(lowerPriv.indexOf("pgpprivatekeyuploadpath") == 0)
				{
					encryption["pgpPrivateKeyUploadPath"] = privs[i].replace("pgpPrivateKeyUploadPath=","");
				}
				else if(lowerPriv.indexOf("pgpencryptupload") == 0)
				{
					encryption["pgpEncryptUpload"] = privs[i].replace("pgpEncryptUpload=","");
				}
				else if(lowerPriv.indexOf("pgppublickeyuploadpath") == 0)
				{
					encryption["pgpPublicKeyUploadPath"] = privs[i].replace("pgpPublicKeyUploadPath=","");
				}
				else if(lowerPriv.indexOf("pgpdecryptdownload") == 0)
				{
					encryption["pgpDecryptDownload"] = privs[i].replace("pgpDecryptDownload=","");
				}
				else if(lowerPriv.indexOf("pgpprivatekeydownloadpassword") == 0)
				{
					encryption["pgpPrivateKeyDownloadPassword"] = privs[i].replace("pgpPrivateKeyDownloadPassword=","");
				}
				else if(lowerPriv.indexOf("pgpprivatekeydownloadpath") == 0)
				{
					encryption["pgpPrivateKeyDownloadPath"] = privs[i].replace("pgpPrivateKeyDownloadPath=","");
				}
				else if(lowerPriv.indexOf("pgpencryptdownload") == 0)
				{
					encryption["pgpEncryptDownload"] = privs[i].replace("pgpEncryptDownload=","");
				}
				else if(lowerPriv.indexOf("pgppublickeydownloadpath") == 0)
				{
					encryption["pgpPublicKeyDownloadPath"] = privs[i].replace("pgpPublicKeyDownloadPath=","");
				}
				else if(lowerPriv.indexOf("syncname") == 0)
				{
					sync["syncName"] = privs[i].replace("syncName=","");
				}
				else if(lowerPriv.indexOf("syncrevisionspath") == 0)
				{
					sync["syncRevisionsPath"] = privs[i].replace("syncRevisionsPath=","");
				}
				else if(lowerPriv.indexOf("syncrevisions") == 0)
				{
					sync["syncRevisions"] = privs[i].replace("syncRevisions=","");
				}
				else if(lowerPriv.indexOf("syncuploadonly") == 0)
				{
					sync["syncUploadOnly"] = privs[i].replace("syncUploadOnly=","");
				}
				else
				{
					userManager.UI.checkUnchekInput(vfsOptions.find("#setup_" + privs[i]), true);
				}
				if(lowerPriv.indexOf("inherited") == 0)
				{
					isInherited = true;
				}
			}
		}
		$("#advancedVFSOptions", vfsOptions).data("privs", {"encryption":encryption, "sync":sync});
		if(isInherited)
		{
			$("#privsOptions", vfsOptions).addClass("ui-priority-secondary");
		}
		else
		{
			$("#privsOptions", vfsOptions).removeClass("ui-priority-secondary");
		}
	}
	else
	{
		$("#privsOptions", vfsOptions).removeClass("ui-priority-secondary");
	}
}

panelSetup.serverDirSelected = function(selected, userStuff)
{
	if(selected)
	{
		var goToDir = selected.attr("path");
		if(selected.attr("upLevel"))
		{
			var curDir = selected.attr("curLevel");
			if(curDir.lastIndexOf("/")==curDir.length-1)
			{
				curDir = curDir.substr(0, curDir.lastIndexOf("/"));
			}
			goToDir = curDir.substr(0, curDir.lastIndexOf("/"));
			if(goToDir.length == 0) goToDir = false;
			var dirDropDown = panelSetup.serverDirSelectList
			if(userStuff)
				dirDropDown = panelSetup.userDirSelectList;

			dirDropDown.find("option[value='"+escape(selected.attr("curLevel"))+"']").nextAll("option").remove();
			dirDropDown.find("option[value='"+escape(selected.attr("curLevel"))+"']").remove();
			dirDropDown.find("option:last").attr("selected", "selected").trigger("change.combo");
			panelSetup.bindServerDirsToBrowse(goToDir, true, userStuff);
		}
		else if(selected.attr("_type") == "dir")
		{
			panelSetup.bindServerDirsToBrowse(goToDir, false, userStuff);
		}
	}
}

panelSetup.formatDirListingItems = function(list)
{
	list = list || panelSetup.serverDirBrowsePanel;
	list.find("li").each(function(){
		var fileName = $(this).text();
		if(fileName.indexOf("/") == 0)
		{
			fileName = fileName.substr(1, fileName.length-1);
			$(this).text(fileName);
		}
		$(this).find("span.ui-icon").remove();
		$(this).prepend('<span style="display: inline-block; margin: 0px 3px 0px -7px;float: left;" class="pointer ui-icon"></span>');
		if($(this).attr("upLevel"))
		{
			$(this).find("span.ui-icon").addClass("ui-icon-arrowreturnthick-1-n");
		}
		else if($(this).attr("_type").toLowerCase()== "dir")
		{
			$(this).find("span.ui-icon").addClass("ui-icon-folder-collapsed");
		}
		else
		{
			$(this).find("span.ui-icon").addClass("ui-icon-document");
		}
	});
	panelSetup.serverDirBrowsePanel.find("li:not(.uplevelLink)").addClass("serverItem").draggable({
		appendTo: "body",
		helper: "clone"
	});
	if(list.attr("id") == panelSetup.vfsItemsDirList.attr("id"))
	{
		panelSetup.bindContextMenu();
	}
}

panelSetup.bindServerDirsToBrowse = function(curDir, loadingFromSelect, userStuff)
{
	curDir = curDir || "/";
	if(curDir.toString() == "null") curDir="/";
	if(curDir != "/" && !loadingFromSelect)
	{
		if(userStuff)
		{
			if(unescape(panelSetup.userDirSelectList.val()) != "/")
				curDir = unescape(panelSetup.userDirSelectList.val()) + curDir;
			else if(curDir.indexOf("/")<0)
				curDir = "/" + curDir;
		}
		else
		{
			if(unescape(panelSetup.serverDirSelectList.val()) != "/")
				curDir = unescape(panelSetup.serverDirSelectList.val()) + curDir;
			else if(curDir.indexOf("/")<0)
				curDir = "/" + curDir;
		}
	}
	if(curDir.lastIndexOf("/")!=curDir.length-1)
	{
		curDir = curDir + "/";
	}
	curDir = unescape(curDir);
	var obj = {
		command: "getAdminXMLListing",
		format: "JSON",
		path: curDir.replace(/\+/g, "%2B"),
		random: Math.random()
	};
	if(userStuff)
	{
		obj.serverGroup = $("#userConnectionGroups").val() || "MainUsers";
		obj.username = panelSetup.loadUser || userManager.storage("userName");
		obj.command = "getUserXMLListing";
		if(!panelSetup.loadUser)
		{
			var perms = panelSetup.generatePrivsXML();
			if(perms)
				obj.permissions = perms;
			var xml = panelSetup.generateVFSXML();
			if(xml)
				obj.vfs_items = xml;
			if(!obj.vfs_items || obj.vfs_items.length == 0)
			{
				obj.vfs_items = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><vfs type=\"properties\"></vfs>";
			}
		}
	}
	/* Make a call and receive list */
	var itemsPanel = panelSetup.serverDirBrowsePanel;
	if(userStuff)
	{
		itemsPanel = panelSetup.vfsItemsDirList;

		var vfsOptions = $("#vfsOptions", panelSetup._panel);
		vfsOptions.find("input[type='checkbox']").each(function(){
			userManager.UI.checkUnchekInput($(this), false);
			$("#privsOptions", vfsOptions).addClass("ui-priority-secondary");
		});
	}
	userManager.UI.showIndicator(false, itemsPanel.closest("td"), "Wait..");
	$.ajax({
		type: "POST",
		url: userManager.ajaxCallURL,
		data: obj,
		success: function (msg){
			userManager.UI.hideIndicator(false, itemsPanel.closest("td"));
			if (msg && msg.childNodes && msg.childNodes.length > 0) {
				var items = $(msg).find("listing").text();
				if(items)
				{
					items = items.replace(/\n/g,' ').replace(/\s/g,' ');
					eval(items);
					if(l && jQuery.isArray(l))
					{
						itemsPanel.empty();
						for(var i=0; i<=l.length;i++)
						{
							var curItem = l[i];
							if(curItem && unescape(curItem.name).length>0)
							{
								var name = unescape(curItem.name.toString());
								if(name.indexOf(".")!=0)
								{
									var hrefPath = curDir + name;
									if(curItem.type.toLowerCase() == "dir")
									{
										 hrefPath += "/";
									}
									var privs = curItem.privs;
									if(!userStuff)
									{
										var GUIXMLPrefs = $(document).data("GUIXMLPrefs");
										if(GUIXMLPrefs && GUIXMLPrefs.user_default_folder_privs)
										{
											privs = GUIXMLPrefs.user_default_folder_privs;
										}
									}
									var newElem = $("<li hrefPath=\""+escape(hrefPath)+"\" curPath=\""+escape(curItem.href_path)+"\" name=\""+curItem.name+"\" path=\""+escape(curItem.name)+"\" privs=\""+privs+"\" _type='"+curItem.type.toLowerCase()+"'>"+name+"</li>");
									itemsPanel.append(newElem);
									newElem.data("hrefPath", userManager.methods.decodeXML(hrefPath));
								}
							}
						}
						if(curDir && curDir != null && curDir != "/")
						{
							if(userStuff)
							{
								if(panelSetup.userDirSelectList.find("option[value='"+escape(curDir)+"']").length==0)
								{
									panelSetup.userDirSelectList.append("<option selected value='"+escape(curDir)+"'>"+curDir+"</option>");
								}
								else
								{
									panelSetup.userDirSelectList.find("option[value='"+escape(curDir)+"']").attr("selected", "selected");
								}
							}
							else
							{
								if(panelSetup.serverDirSelectList.find("option[value='"+escape(curDir)+"']").length==0)
								{
									panelSetup.serverDirSelectList.append("<option selected value='"+escape(curDir)+"'>"+curDir+"</option>").trigger("change.combo");
								}
								else
								{
									panelSetup.serverDirSelectList.find("option[value='"+escape(curDir)+"']").attr("selected", "selected");
								}
							}
							itemsPanel.prepend("<li curLevel=\""+curDir+"\" class='uplevelLink' upLevel=\"true\">..</li>");
						}
						else if(curDir && curDir != null)
						{
							if(userStuff)
							{
								panelSetup.userDirSelectList.val(escape(curDir)).find("option:selected").nextAll("option").remove();
							}
							else
							{
								panelSetup.serverDirSelectList.val(escape(curDir)).find("option:selected").nextAll("option").remove();
							}
						}
						if(itemsPanel.find("li:first").length>0)
							itemsPanel.parent().scrollTo(itemsPanel.find("li:first"));

						panelSetup.formatDirListingItems(itemsPanel);
						if(userStuff)
						{
							if(itemsPanel.find("li:not(.uplevelLink)").length==1)
							{
								panelSetup.vfsItemSelected(itemsPanel, itemsPanel.find("li:not(.uplevelLink):first").addClass("ui-selected ui-widget-header"), true);
							}
							else if(panelSetup.lastDroppedItem)
							{
								var matchedElem = $();
								itemsPanel.find("li").each(function(){
									if($(this).data("hrefPath") == panelSetup.lastDroppedItem)
									{
										matchedElem = $(this);
										return;
									}
								});
								panelSetup.vfsItemSelected(itemsPanel, matchedElem.addClass("ui-selected ui-widget-header"), true);
								panelSetup.lastDroppedItem = false;
							}
							panelSetup.showHideVFSOperationButtons();
						}
						else
						{
							panelSetup.showHideServerOperationButtons();
						}
					}
				}
			}
		},
		error: function (XMLHttpRequest, textStatus, errorThrown) {
			errorThrown = errorThrown || "The path requested is not accessible or no longer available : \"" + obj.path + "\"";
			userManager.UI.growl("Error : ", errorThrown, true, true);
			userManager.UI.hideIndicator(false, itemsPanel.closest("td"));
		}
	});
}

panelSetup.generateVFSXML = function(curUserJson)
{
	var xml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
	// VFS Items
	xml += "\r\n<vfs_items type=\"vector\">";
	var itemsAvailable = false;
	curUserJson = curUserJson || userManager.storage("currentUser");
	if(curUserJson && curUserJson.vfs_items && curUserJson.vfs_items.vfs_items_subitem)
	{
		var items = curUserJson.vfs_items.vfs_items_subitem;
		if(items)
		{
			for(var curItem in items)
			{
				var item = items[curItem].vfs_items_subitem_subitem;
				if(!item)item = items[curItem];
				if(item && item.name)
				{
					var path = item.path || "";
					if(item.name.toLowerCase() == "vfs" && path == "" && item.url == "" && item.type.toLowerCase()=="dir")
					{
						xml += "";
					}
					else
					{
						xml += "\r\n<vfs_items_subitem type=\"properties\">";
							xml += "\r\n<name>"+userManager.methods.htmlEncode(unescape(userManager.methods.decodeXML(item.name))).replace(/\+/g, "%2B")+"</name>";
							xml += "\r\n<path>"+userManager.methods.htmlEncode(unescape(userManager.methods.decodeXML(path))).replace(/\+/g, "%2B")+"</path>";
							xml += "\r\n<vfs_item type=\"vector\">";
								xml += "\r\n<vfs_item_subitem type=\"properties\">";
									for(var prop in item)
									{
										if(prop != "name" && prop != "path")
										{
											var val = userManager.methods.htmlEncode(unescape(userManager.methods.decodeXML(item[prop]))).replace(/\+/g, "%2B");
											if(prop == "type")
											{
												if(val.toLowerCase() == "properties")
													val = "dir";
												xml += "\r\n<"+prop+">" + val.toUpperCase()+ "</"+prop+">";
											}
											else
												xml += "\r\n<"+prop+">" + val + "</"+prop+">";
										}
									}
								xml += "\r\n</vfs_item_subitem>";
							xml += "\r\n</vfs_item>";
						xml += "\r\n</vfs_items_subitem>";
						itemsAvailable = true;
					}
				}
			}
		}
	}
	if(!itemsAvailable)
	{
		return false;
	}
	else
	{
		xml += "\r\n</vfs_items>";
		return xml;
	}
}

panelSetup.generatePrivsXML = function()
{
	var currentUserDirPrivs = userManager.storage("currentUserDirPrivs");
	var xml = "";
	var itemsAvailable = false;
	if(currentUserDirPrivs)
	{
		// Privs for items
		xml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
		xml += "\r\n<VFS type=\"properties\">";
		for(var curItem in currentUserDirPrivs)
		{
			var privs = currentUserDirPrivs[curItem];
			if(typeof privs  != "undefined" && typeof curItem  != "undefined")
			{
				xml += "\r\n<item name=\""+userManager.methods.htmlEncode(unescape(userManager.methods.decodeXML(curItem.toUpperCase()))).replace(/\+/g, "%2B")+"\">"+userManager.methods.htmlEncode(unescape(userManager.methods.decodeXML(privs))).replace(/\+/g, "%2B")+"</item>";
				itemsAvailable = true;
			}
		}
		xml += "\r\n</VFS>";
	}
	if(!itemsAvailable)
	{
		return false;
	}
	else
	{
		return xml;
	}
}

panelSetup.generateXML = function()
{
	var xml = "";
	//General items
	panelSetup._panel.find("td.checkboxArea").not(".specialProperty").find("input:checked").each(function(){
		var formPanel = $(this).closest("td").next();
		xml += "\r\n" + userManager.data.buildXMLToSubmitForm(formPanel);
	});

	//Linked VFS
	if(panelSetup._panel.find("#linkedVFSCheck").find("input:checked").length>0)
	{
		xml += "\r\n<linked_vfs type=\"vector\">";
		var vfsLinks = $("#vfsLinks", panelSetup._panel);
		vfsLinks.find("li").each(function(){
			var vfsData = $(this).data("controlData");
			if(vfsData)
			{
				xml += "\r\n<linked_vfs_subitem>"+ vfsData +"</linked_vfs_subitem>";
			}
		});
		xml += "\r\n</linked_vfs>";
	}
	return xml;
}